
// Rtf2HtmGUIDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Rtf2HtmGUI.h"
#include "Rtf2HtmGUIDlg.h"
#include "HtmlEditCtrlEx.h"
#include "DlgViewSrc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CRtf2HtmGUIDlg dialog

CRtf2HtmGUIDlg::CRtf2HtmGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRtf2HtmGUIDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRtf2HtmGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RICHEDIT21, m_ctlRichEdit);
}

BEGIN_MESSAGE_MAP(CRtf2HtmGUIDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDPB_LoadRtf, &CRtf2HtmGUIDlg::OnBnClickedLoadRtf)
	ON_BN_CLICKED(IDPB_Convert, &CRtf2HtmGUIDlg::OnBnClickedConvert)
	ON_BN_CLICKED(IDPB_SaveAsHtml, &CRtf2HtmGUIDlg::OnBnClickedSaveAsHtml)
	ON_BN_CLICKED(IDPB_ViewRtfSrc, &CRtf2HtmGUIDlg::OnBnClickedViewRtfSrc)
	ON_BN_CLICKED(IDPB_ViewHtmSrc2, &CRtf2HtmGUIDlg::OnBnClickedViewHtmSrc)
END_MESSAGE_MAP()


// CRtf2HtmGUIDlg message handlers

BOOL CRtf2HtmGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// put the HTlm Editor in place
	m_ctlEditHtml.CreateFromStatic( IDST_HtmlBox, this );
	m_ctlEditHtml.EnableContextMenu( false );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRtf2HtmGUIDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRtf2HtmGUIDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

static DWORD CALLBACK 
MyStreamInCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
   CFile* pFile = (CFile*) dwCookie;
   *pcb = pFile->Read(pbBuff, cb);
   return 0;
}

void CRtf2HtmGUIDlg::OnBnClickedLoadRtf()
{
	wchar_t szFilter[] = L"RTF files (*.rtf)|*.rtf;|"
		                 L"All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE,0,0,6,szFilter );
	if ( dlg.DoModal()!=IDOK ) {
		return;
	}
	//-------------------------------------- read the RTF file into memory
	m_sRtfFile= dlg.GetPathName();
	CFile cf( m_sRtfFile,CFile::modeRead );

	EDITSTREAM es;
	es.dwCookie = (DWORD)&cf;
	es.pfnCallback = MyStreamInCallback; 
	m_ctlRichEdit.StreamIn(SF_RTF, es);
}

void CRtf2HtmGUIDlg::OnBnClickedConvert()
{
	m_ctlRichEdit.SetSel(0,-1);
	m_ctlRichEdit.Copy();

	m_ctlEditHtml.Paste();
}

void CRtf2HtmGUIDlg::OnBnClickedSaveAsHtml()
{
	m_ctlEditHtml.SaveAs();
}


void CRtf2HtmGUIDlg::ViewSrc()
{
	
}

void CRtf2HtmGUIDlg::OnBnClickedViewRtfSrc()
{
	CFile cf( m_sRtfFile,CFile::modeRead );
	int nLen=cf.GetLength();
	BYTE* pabData= new BYTE[nLen+2];
	cf.Read( pabData,nLen );
	
	CDlgViewSrc dlg;
	dlg.m_sSrcTxt= pabData;
	dlg.DoModal();
}

void CRtf2HtmGUIDlg::OnBnClickedViewHtmSrc()
{
	CDlgViewSrc dlg;
	m_ctlEditHtml.GetDocumentHTML( dlg.m_sSrcTxt );	
	dlg.DoModal();
}
